/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * MetaData类继承自Task类，用于管理任务的元数据。
 * 该类提供了设置和获取与任务相关的GID的方法，以及处理远程JSON内容的方法。
 */
public class MetaData extends Task {
    // 日志标签，用于调试输出
    private final static String TAG = MetaData.class.getSimpleName();

    // 相关的GID
    private String mRelatedGid = null;

    /**
     * 设置元数据
     * @param gid 任务的GID
     * @param metaInfo 元数据的JSON对象
     */
    public void setMeta(String gid, JSONObject metaInfo) {
        try {
            // 将GID添加到元数据JSON对象中
            metaInfo.put(GTaskStringUtils.META_HEAD_GTASK_ID, gid);
        } catch (JSONException e) {
            // 输出错误日志
            Log.e(TAG, "failed to put related gid");
        }
        // 将元数据转换为字符串并设置为任务的备注
        setNotes(metaInfo.toString());
        // 设置任务名称
        setName(GTaskStringUtils.META_NOTE_NAME);
    }

    /**
     * 获取相关的GID
     * @return 相关的GID
     */
    public String getRelatedGid() {
        return mRelatedGid;
    }

    /**
     * 判断任务是否值得保存
     * @return 如果任务的备注不为空，则返回true；否则返回false
     */
    @Override
    public boolean isWorthSaving() {
        return getNotes() != null;
    }

    /**
     * 通过远程JSON内容设置任务内容
     * @param js 远程JSON对象
     */
    @Override
    public void setContentByRemoteJSON(JSONObject js) {
        super.setContentByRemoteJSON(js);
        if (getNotes() != null) {
            try {
                // 解析备注中的元数据JSON对象
                JSONObject metaInfo = new JSONObject(getNotes().trim());
                // 获取元数据中的GID
                mRelatedGid = metaInfo.getString(GTaskStringUtils.META_HEAD_GTASK_ID);
            } catch (JSONException e) {
                // 输出警告日志
                Log.w(TAG, "failed to get related gid");
                mRelatedGid = null;
            }
        }
    }

    /**
     * 禁止通过本地JSON内容设置任务内容
     * @param js 本地JSON对象
     */
    @Override
    public void setContentByLocalJSON(JSONObject js) {
        // 此方法不应被调用
        throw new IllegalAccessError("MetaData:setContentByLocalJSON should not be called");
    }

    /**
     * 禁止从任务内容中获取本地JSON对象
     * @return 本地JSON对象
     */
    @Override
    public JSONObject getLocalJSONFromContent() {
        throw new IllegalAccessError("MetaData:getLocalJSONFromContent should not be called");
    }

    /**
     * 禁止获取同步动作
     * @param c 游标对象
     * @return 同步动作
     */
    @Override
    public int getSyncAction(Cursor c) {
        throw new IllegalAccessError("MetaData:getSyncAction should not be called");
    }
}
